
from conversion import isList
import scipy.stats
import numpy.random
import operator

class Distribution:
    """
    """
    
    def cdf(self, x):
        """Cumulative distribution function.
        
        :param x:       
        :type x:        
        :returns:       
        
        """
        abstract()
    
    def pdf(self, x):
        """Probability density function.
        
        :param x:       
        :type x:        
        :returns:       
        
        """
        abstract()
    
    def sample(self, N=1):
        """Draw samples from the distribution.
        
        :param N:       Number of samples.
        :type N:        int
        :returns:       list of samples, drawn from the distribution.
        
        """
        abstract()
    
    def fit(self, data):
        """Fit the distribution to samples.
        
        :param data:    
        :type data:     
        :returns:       self
        
        """
        abstract()

class Gaussian(Distribution):
    """
    """
    
    def __init__(self, mu=0.0, sig=1.0):
        """
        :param mu:      Distribution mean.
        :type mu:       float, scipy.matrix
        :param sig:     Distribution variance.
        :type sig:      float, scipy.matrix
        
        """
        self.mu = mu
        self.sig = sig
    
    def cdf(self, x):
        return scipy.stats.norm.cdf(x, loc=self.mu, scale=self.sig)
    
    def pdf(self, x):
        return scipy.stats.norm.pdf(x, loc=self.mu, scale=self.sig)

    def sample(self, N=1):
        if self.__isMultivariate():
            if N > 1:
                return reduce(operator.add, numpy.random.multivariate_normal(self.mu, self.sig, (N,1)).tolist())
            else:
                return numpy.random.multivariate_normal(self.mu, self.sig).tolist()
        else:
            if N > 1:
                return reduce(operator.add, numpy.random.normal(self.mu, self.sig, (N,1)))
            else:
                return numpy.random.normal(self.mu, self.sig)

    def fit(self, data):
        """
        :param data:    
        :type data:     
        :returns:       
        """
        if len(data) == 0: pass #Error
        
        # univariate case
        self.mu = mean(data)
        self.sig = var(data)
        
        #[(x00,x01,x02, ...), (x10,x11,x12, ...), ...] => [(x00,x10,..), (x01,x11,..), (x02,x12,..), ..]
        #self.mu = ??
        #self.sig = numpy.cov(data)
        return self

    def __isMultivariate(self):
        """Check, if the current configuration is multivariate."""
        return isList(self.mu)
        

class Laplace(Distribution):
    pass

class Exponential(Distribution):
    pass

class Uniform(Distribution):
    pass

class GaussianMixture(Distribution):
    pass

class Discrete(Distribution):
    pass
