#
#pDist = @(i) 2^(-0.1*i) / 6.9663630864564823;
#qDist = @(x) 1/10;
#qSampler = @() randsample(10,1);
#weights = iSampler(qSampler, qDist, pDist, N);
#
#%
#% Importance sampling
#%
#% Input
#%    qSampler    Sampler function of q
#%    qDist        proposal probability density function
#%    pDist        probability mass function
#%    N        number of samples
#% Output
#%    weights        importance weights
#%
#function weights = iSampler(qSampler,qDist,pDist,N)
#  weights = zeros(N,1);
#  for i=1:N
#    y = qSampler();
#    w = pDist(y) / qDist(y);
#    weights(i) = w;
#  end
#end
#
#

def importanceSampler(qSampler, qDist, pDist, N):
    samples = []
    for i in range(N):
        y = qSampler()
        w = pDist(y) / qDist(y)
        samples.append( (y, w) )
    return samples # return discrete distribution instead
